﻿
// MFCPointerNetworkDlg.cpp: файл реализации
//

#include "pch.h"
#include "framework.h"
#include "MFCPointerNetwork.h"
#include "MFCPointerNetworkDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//====================================================
// Описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
// Автор исходных кодов Клочков Павел
//====================================================


// Диалоговое окно CAboutDlg используется для описания сведений о приложении

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Данные диалогового окна
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // поддержка DDX/DDV

// Реализация
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
	
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// Диалоговое окно CMFCPointerNetworkDlg



CMFCPointerNetworkDlg::CMFCPointerNetworkDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MFCPOINTERNETWORK_DIALOG, pParent)
	, m_MainSocket(this)
	, m_AcceptSocket(this)
	, m_IsServer(FALSE)
	, m_IsClient(FALSE)
	, m_Port(10000)
	, m_IP(_T("127.0.0.1"))
	, m_valueString(_T(""))
	, m_valueArrayChar(_T(""))
	, m_valueInt(0)
	, m_valueArrayInt0(0)
	, m_valueArrayInt1(0)
	, m_valueArrayInt2(0)
	, m_valueArrayInt3(0)
	, m_Status(_T(""))
	, m_valueDouble(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
}

void CMFCPointerNetworkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_RADIO_SERVER, m_IsServer);
	DDX_Check(pDX, IDC_RADIO_CLIENT, m_IsClient);
	DDX_Text(pDX, IDC_EDIT_PORT, m_Port);
	DDX_Text(pDX, IDC_EDIT_IP, m_IP);
	DDX_Text(pDX, IDC_EDIT_STRING, m_valueString);
	DDX_Text(pDX, IDC_EDIT_ARRAYCHAR, m_valueArrayChar);
	DDX_Text(pDX, IDC_EDIT_INT, m_valueInt);
	DDX_Text(pDX, IDC_EDIT_ARRAYINT0, m_valueArrayInt0);
	DDX_Text(pDX, IDC_EDIT_ARRAYINT1, m_valueArrayInt1);
	DDX_Text(pDX, IDC_EDIT_ARRAYINT2, m_valueArrayInt2);
	DDX_Text(pDX, IDC_EDIT_ARRAYINT3, m_valueArrayInt3);
	DDX_Text(pDX, IDC_STATIC_STATUS, m_Status);
	DDX_Text(pDX, IDC_EDIT_DOUBLE, m_valueDouble);
}

BEGIN_MESSAGE_MAP(CMFCPointerNetworkDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, &CMFCPointerNetworkDlg::OnBnClickedButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CMFCPointerNetworkDlg::OnBnClickedButtonSend)
	ON_BN_CLICKED(IDC_RADIO_SERVER, &CMFCPointerNetworkDlg::OnBnClickedRadioServer)
	ON_BN_CLICKED(IDC_RADIO_CLIENT, &CMFCPointerNetworkDlg::OnBnClickedRadioClient)
END_MESSAGE_MAP()


// Обработчики сообщений CMFCPointerNetworkDlg

BOOL CMFCPointerNetworkDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Добавление пункта "О программе..." в системное меню.

	// IDM_ABOUTBOX должен быть в пределах системной команды.
	//ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	//ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Задает значок для этого диалогового окна.  Среда делает это автоматически,
	//  если главное окно приложения не является диалоговым
	SetIcon(m_hIcon, TRUE);			// Крупный значок
	SetIcon(m_hIcon, FALSE);		// Мелкий значок

	// TODO: добавьте дополнительную инициализацию

	return TRUE;  // возврат значения TRUE, если фокус не передан элементу управления
}

void CMFCPointerNetworkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// При добавлении кнопки свертывания в диалоговое окно нужно воспользоваться приведенным ниже кодом,
//  чтобы нарисовать значок.  Для приложений MFC, использующих модель документов или представлений,
//  это автоматически выполняется рабочей областью.

void CMFCPointerNetworkDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // контекст устройства для рисования

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Выравнивание значка по центру клиентского прямоугольника
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Нарисуйте значок
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// Система вызывает эту функцию для получения отображения курсора при перемещении
//  свернутого окна.
HCURSOR CMFCPointerNetworkDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CMFCPointerNetworkDlg::OnAccept(BOOL error)
{
	// Только один клиент одновременно будет на связи.
	// При подключении нового клиента с предыдущим связь закрывается.
	// Это только для упрощения исходного кода.
	m_AcceptSocket.Close();


	// Если все в порядке добавим рабочий сокет в список 
	// подключенных рабочих сокетов.
	if (m_MainSocket.Accept(m_AcceptSocket) == TRUE)
	{
		SetWindowText(L"Сервер: клиент подключился!");
	}
	else
	{
		MessageBox(L"Ошибка подключения клиента!");
	}
}


void CMFCPointerNetworkDlg::OnConnect(BOOL error)
{
	if (error == TRUE)
	{
		CUtil::BeepError();

		MessageBox(L"Попытка подключения была отвергнута!\nВозможно сервер еще не создан!");
	}
	else
	{
		SetWindowText(L"Клиент: сеть работает!");
	}
}


void CMFCPointerNetworkDlg::OnReceive(BOOL error)
{
	CMySocket* pSockReceive = NULL;

	if (m_IsServer == TRUE) pSockReceive = &m_AcceptSocket;

	if (m_IsClient == TRUE) pSockReceive = &m_MainSocket;


	if (pSockReceive != NULL)
	{
		ParseReceiveData(pSockReceive);

		
		UpdateData(FALSE);
	}

}


void CMFCPointerNetworkDlg::OnCloseSocket(BOOL error)
{
	if (m_IsServer == TRUE)
	{
		MessageBox(L"Клиент отсоединился!");

		this->EndDialog(0);
	}


	if (m_IsClient == TRUE)
	{
		MessageBox(L"Сервер закрыл соединение!");

		this->EndDialog(0);
	}
}


void CMFCPointerNetworkDlg::OnBnClickedButtonClose()
{
	// Закрытие приложения с кодом 0.
	this->EndDialog(0);
}

void CMFCPointerNetworkDlg::OnBnClickedButtonSend()
{
	// При вызове этой функции TRUE данные из оконных элементов диалога 
	// копируются в связанные с ними переменными.
	UpdateData(TRUE);

	if (m_FlagSent == FALSE) return;

	CMySocket* pSockSend = NULL;

	if (m_IsServer == TRUE) pSockSend = &m_AcceptSocket;

	if (m_IsClient == TRUE) pSockSend = &m_MainSocket;




	if (pSockSend != NULL)
	{
		// Ставим флаг процесса отправки.
		// Пока партия данных не отправлена, следующую отправлять нельзя.
		m_FlagSent = FALSE;


		// Размер буфера отправки. 
		// Для наибольшего КПД, размер пакета должен быть равен размеру буфера отправки.
		int sizeBuffer = 0;
		int len = 4;
		if (pSockSend->GetSockOpt(SO_RCVBUF, &sizeBuffer, &len) == FALSE)
		{
			CUtil::BeepError();
		}


		// Объект, данные которого передаются по сети
		CPointers pointers;

		// 
		pointers.m_pInt = new int;
		*pointers.m_pInt = m_valueInt;


		pointers.m_pDouble = new double;
		*pointers.m_pDouble = m_valueDouble;


		// 
		int temp[4] = { m_valueArrayInt0, m_valueArrayInt1, m_valueArrayInt2, m_valueArrayInt3 };
		pointers.SetArrayInt(temp, 4);
		int sizeArrayInt = pointers.GetSizeArrayInts();


		//
		pointers.m_String = m_valueString;
		int sizeString = 0;
		LPCTSTR pString = pointers.GetDataString(sizeString);

		//
		pointers.SetArrayTCHAR(m_valueArrayChar);
		int tcharSize = pointers.GetSizeArrayTCHAR();


		// Информационный класс.
		CSendInfo cSendInfo;
		cSendInfo.m_SizeString = sizeString;
		cSendInfo.m_SizeArrayTCHAR = tcharSize;
		cSendInfo.m_SizeArrayInt = sizeArrayInt;


		// Итоговый размер всех данных.
		int totalDataSize = sizeof(CSendInfo) + sizeof(int) + sizeof(double) + cSendInfo.m_SizeArrayInt + cSendInfo.m_SizeString + cSendInfo.m_SizeArrayTCHAR;
		cSendInfo.m_TotalDataSize = totalDataSize;
		
		
		// Общий буфер для отправляемых данных
		BYTE* totalBuffer = new BYTE[totalDataSize];
		ZeroMemory(totalBuffer, totalDataSize);

		
		// Сдвиг адреса для добавления новых данных в общий буфер.
		int offset = 0;


		// Копирование байтов CSendInfo
		memcpy(totalBuffer + offset, &cSendInfo, sizeof(CSendInfo));


		// Копирование байтов pointers.m_pInt
		offset += sizeof(CSendInfo);
		memcpy(totalBuffer + offset, pointers.m_pInt, sizeof(int));


		// Копирование байтов pointers.m_pDouble
		offset += sizeof(int);
		memcpy(totalBuffer + offset, pointers.m_pDouble, sizeof(double));


		// Bytes of pointers.m_pArrayInt
		offset += sizeof(double);
		memcpy(totalBuffer + offset, pointers.m_pArrayInt, sizeArrayInt);


		// pString
		offset += sizeArrayInt;
		memcpy(totalBuffer + offset, pString, sizeString);


		// Массив символов 
		offset += sizeString;
		memcpy(totalBuffer + offset, pointers.m_pTCHAR, tcharSize);

		
		// Реально отправленное количество
		int totalActualSend = 0;
		
		// Отправка данных пакетами.
		while (totalActualSend < totalDataSize)
		{
			// Если размер буфера позволит, отправим всё сразу.
			int sizeCompute = (totalDataSize - totalActualSend);

			// Но если размер отправляемых данных больше буфера,
			// размер пакета устанавливаем равным буферу. 
			// Если меньше размер пакета остаётся равен отправляемому остатку.
			if ((totalDataSize - totalActualSend) > sizeBuffer)
			{
				sizeCompute = sizeBuffer;
			}
		

			// Подсчитываем реально отправляемые данные.
			int sent = pSockSend->Send(totalBuffer + totalActualSend, sizeCompute);
			totalActualSend += sent;
		}

		// Сброс данных для отправки следующей партии.
		if (totalActualSend == totalDataSize)
		{
			delete [] totalBuffer;
			totalBuffer = NULL;

			m_FlagSent = TRUE;

			//CUtil::BeepOk();
		}

		// Вывод статуса.
		m_Status = _T(" Отправлено: ") + CUtil::IntToStr(totalActualSend) + _T("(")  + CUtil::IntToStr(totalDataSize) + _T(") байт");

		UpdateData(FALSE);
	}

}


void CMFCPointerNetworkDlg::OnBnClickedRadioServer()
{
	UpdateData(TRUE);

	// Создавать сокет можно только если он нулевой.
	// Если сокет уже возвращает рабочий дескриптор выходим из метода.
	if (m_MainSocket.m_hSocket != INVALID_SOCKET)
	{
		CUtil::BeepError();

		int err = WSAGetLastError();
		CString s;
		s.Format(_T("Сокет уже инициализирован\n Error %d"), err);
		MessageBox(s);

		return;
	}

	if (m_MainSocket.Create(m_Port) == TRUE)
	{
		if (m_MainSocket.Listen() == TRUE)
		{
			SetWindowText(_T("Сервер на прослушивании..."));
		}
		else
		{
			CUtil::BeepError();
		}
	}
	else
	{
		CUtil::BeepError();
	}
}


void CMFCPointerNetworkDlg::OnBnClickedRadioClient()
{
	UpdateData(TRUE);

	if (m_MainSocket.m_hSocket != INVALID_SOCKET)
	{
		CUtil::BeepError();

		int err = WSAGetLastError();
		CString s;
		s.Format(_T("Сокет уже инициализирован\n Error %d"), err);
		MessageBox(s);


		return;
	}

	// Класс CAsyncSocket упрощает процедуру создания сокета,
	// вкладывая в функцию Create() непосредственное создание 
	// сокета и связывание его с одним из IP адресом доступном на компьютере.
	if (m_MainSocket.Create() == TRUE)
	{
		if (m_MainSocket.Connect(m_IP, m_Port) == FALSE)
		{

			// Ресурс временно недоступен.
			// В ассинхронном режиме код этой ошибки
			// считается как ожидание события подключения,
			// т.е. практически успешный возврат.
			// Это когда операция не может быть завершена 
			// немедленно.
			if (GetLastError() == WSAEWOULDBLOCK)
			{

			}
			else
			{
				CUtil::BeepError();
			}
		}
	}
}




void CMFCPointerNetworkDlg::OnSend(BOOL error)
{
	// Приложение готово к отправке

	if (error == FALSE)
	{
		CUtil::BeepOk();
	}
	else
	{
		CUtil::BeepError();
	}
}


BOOL CMFCPointerNetworkDlg::ParseReceiveData(CMySocket* recvSocket)
{

	DWORD recvSize = 0;
	
	if (recvSocket->IOCtl(FIONREAD, &recvSize) == TRUE)
	{
		CPointers pointersReceive;


		if (m_InfoOk == FALSE)
		{
			// Размер CSendInfo не более 20 байт. Первый пакет, с высокой вероятностью, 
			// размером больше чем объект CSendInfo.
			// Но для коммерческих версий здесь необходим 
			// код обработки ситуации когда recvSize < sizeof(CSendInfo).
			// В последующих статьях я добавлю этот код.
			//if (recvSize >= sizeof(CSendInfo))
			//{
				BYTE* buffer = new BYTE[recvSize];

				int check = recvSocket->Receive(buffer, recvSize);

				m_CounterRecv += check;
				
				// 
				memcpy_s(&m_sendInfo, sizeof(CSendInfo), buffer, sizeof(CSendInfo));

				m_DataBuffer = new BYTE[m_sendInfo.m_TotalDataSize];

				memcpy_s(m_DataBuffer, recvSize, buffer, recvSize);

				m_InfoOk = TRUE;
				delete[] buffer;
				buffer = NULL;

			//}
		}
		else
		{
			int check = recvSocket->Receive(m_DataBuffer + m_CounterRecv, recvSize);

			m_CounterRecv += check;
		}



		// Проверка окончания приёма данных.
		if (m_sendInfo.m_TotalDataSize > 0 && m_CounterRecv >= m_sendInfo.m_TotalDataSize)
		{
			// Возможная ошибка.
			if (m_CounterRecv > m_sendInfo.m_TotalDataSize)
			{
				CUtil::BeepError();
			}

			
			// Смещение точки отсчёта для копирования следующих данных.
			int offset = sizeof(CSendInfo);



			// --- Получаем значение m_pInt класса CPointers ---

			int* i = new int;
			memcpy_s(i, sizeof(int), m_DataBuffer + offset, sizeof(int));

			pointersReceive.m_pInt = i;
			m_valueInt = *pointersReceive.m_pInt;

			
			// --- Получаем значение m_pDouble класса CPointers ---

			offset += sizeof(int);
			double* d = new double;
			memcpy_s(d, sizeof(double), m_DataBuffer + offset, sizeof(double));

			pointersReceive.m_pDouble = d;
			m_valueDouble = *pointersReceive.m_pDouble;


			// --- Получаем значение массива целочисленных значений CPointers::m_pArrayInt --- 

			offset += sizeof(double);
			int* pArrayInt = new int[m_sendInfo.m_SizeArrayInt];
			memcpy_s(pArrayInt, m_sendInfo.m_SizeArrayInt, m_DataBuffer + offset, m_sendInfo.m_SizeArrayInt);

			pointersReceive.m_pArrayInt = pArrayInt;

			m_valueArrayInt0 = pointersReceive.m_pArrayInt[0];
			m_valueArrayInt1 = pointersReceive.m_pArrayInt[1];
			m_valueArrayInt2 = pointersReceive.m_pArrayInt[2];
			m_valueArrayInt3 = pointersReceive.m_pArrayInt[3];


			// --- Получаем данные строки CString m_String класса CPointers --- 

			offset += m_sendInfo.m_SizeArrayInt;
			BYTE* pString = new BYTE[m_sendInfo.m_SizeString];
			memcpy_s(pString, m_sendInfo.m_SizeString, m_DataBuffer + offset, m_sendInfo.m_SizeString);

			pointersReceive.m_String = (LPCTSTR)pString; //(TCHAR*)pString;
			m_valueString = pointersReceive.m_String; 

			// Байты строки pString полностью копируются в объект pointersReceive.m_String,
			// поэтому память занятую pString необходимо освобождать.
			delete[] pString;
			pString = NULL;


			// --- Поучаем байты массива символов CPointers::m_pTCHAR ---

			offset += m_sendInfo.m_SizeString;
			TCHAR* pArrayChar = new TCHAR[m_sendInfo.m_SizeArrayTCHAR];
			memcpy_s(pArrayChar, m_sendInfo.m_SizeArrayTCHAR, m_DataBuffer + offset, m_sendInfo.m_SizeArrayTCHAR);
			 
			pointersReceive.m_pTCHAR = pArrayChar;
			m_valueArrayChar = pointersReceive.m_pTCHAR;



			// Освобождаем память занятую главным буфером.
			delete[] m_DataBuffer;
			m_DataBuffer = NULL;


			// Получена точная копия объекта класса CPointers, данные которого 
			// были отправлены в сеть.
			// pointersReceive

			// Индикация статуса приёма данных.			
			m_Status = L" Получено:" + CUtil::IntToStr(m_CounterRecv) + L" байт";

			// Сброс глобальных переменных-членов для следующей партии данных.
			m_CounterRecv = 0;
			m_sendInfo.Reset();
			m_InfoOk = FALSE;
		}

		
	}
	else
	{
		CUtil::BeepError();
	}


	UpdateData(FALSE);

	return FALSE;
}

